# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import playerlib
import keyvalues
import popuplib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS

func = es.import_addon('sam/functions')

# * VARIABLES

db     = 'sam_admins'
db_dir = 'cstrike/cfg/sam/databases/es_sam_admins_db.txt'
access = [
		'Admins Manager',
		'Addons Manager',
		'Kick',
		'Ban Level 1',
		'Ban Level 2',
		'Unban',
		'Move Players',
		'Slay',
		'Mute',
		'Server Commands',
		'Remote RCON',
		'Admin Chat',
		]

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
langDir    = es.getAddonPath('sam') + '/langs/'
popupText  = langlib.Strings(langDir + 'admins/popups.ini')
adminsText = langlib.Strings(langDir + 'admins/admins.ini')
adminstag  = func.commonText('tag_admins', None, func.getLang())
hudtag     = 'ADMINS'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	''' Temp Vars '''
	es.set('sam_first_admin', 0)

	''' Load Keygroups '''
	if os.path.isfile(db_dir) == True: es.keygroupload(db, func.default.dbfiles)

	''' Update Admins '''
	if checkDB:
		for ply in playerlib.getPlayerList('#human'):
			if isAdmin(ply.steamid): updateAdmin(ply.steamid)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' Deletes '''
	if es.exists('keygroup', db) == 1: es.keygroupdelete(db)

	''' Popups '''
	func.popupDelete('firstAdmin')

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def isAdmin(target):
	if es.exists('key', db, target): return True
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getAdmin(target):
	if isAdmin(target):
		admin = {'steamid':target,'immunity':es.keygetvalue(db, target, 'immunity'),'name':es.keygetvalue(db, target, 'name')}
		for item in access: admin[item] = es.keygetvalue(db, target, item)
		return admin
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkAccess(target, item):
	if isAdmin(target):
		admin  = getAdmin(target)
		access = 0
		if item == 'Ban':
			if admin['Ban Level 1'] == 'yes' or admin['Ban Level 2'] == 'yes': access = 1
		elif admin[item] == 'yes': access = 1
		if access == 1: return True
		else:
			func.hudhint(es.getuserid(target), adminsText('no_access', None, func.getLang()), hudtag)
			return False
	else:
		func.hudhint(es.getuserid(target), adminsText('no_access', None, func.getLang()), hudtag)
		return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkImmunity(admin, target):
	if not admin == None:
		if isAdmin(target):
			adminIM  = getAdmin(admin)
			targetIM = getAdmin(target)
			if int(adminIM['immunity']) > int(targetIM['immunity']): return True
			elif int(adminIM['immunity']) <= int(targetIM['immunity']):
				if int(adminIM['immunity']) > 0:
					func.hudhint(es.getuserid(admin), adminsText('lowerRank', None, func.getLang()))
					return False
				else: return True
		else: return True
	else: return True

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def addAdmin(userid, target):
	target = playerlib.getPlayer(es.getuserid(target))
	if checkDB() == False: es.keygroupcreate(db)
	if es.exists('key', db, target.steamid):
		es.keydelete(db, target.steamid)
		es.keygroupsave(db, func.default.dbfiles)
	es.keycreate(db, target.steamid)
	es.keysetvalue(db, target.steamid, 'name', target.name)
	es.keysetvalue(db, target.steamid, 'immunity', 0)
	for item in access: es.keysetvalue(db, target.steamid, item, 'yes')
	es.keygroupsave(db, func.default.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def removeAdmin(userid, target):
	if isAdmin(target):
		admins = 0
		for admin in keyvalues.getKeyGroup(db): admins += 1
		if admins > 1:
			es.keydelete(db, target)
			es.keygroupsave(db, func.default.dbfiles)
		else: func.hudhint(userid, adminsText('notEnoughAdmins', None, func.getLang()), hudtag)
	else: func.hudhint(userid, adminsText('not_admin', None, func.getLang()), hudtag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkDB():
	if os.path.isfile(db_dir) == True:
		if es.exists('keygroup', db) == 1: return True
		else:
			es.set('sam_first_admin', 1)
			return False
	else:
		es.set('sam_first_admin', 1)
		return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def updateAdmin(admin):
	admin = getAdmin(admin)
	es.keysetvalue(db, admin['steamid'], 'name', es.getplayername(es.getuserid(admin['steamid'])))
	for item in access:
		if not es.exists('keyvalue', db, admin['steamid'], item): es.keysetvalue(db, admin['steamid'], item, 'no')
	es.keygroupsave(db, func.default.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def chatFilter(userid, text, teamonly):
	var = es.ServerVar('sayfilter_%s' % (userid))
	if int(var) == 1:
		text = text.strip('"')
		es.set('sayfilter_%s' % (userid), 0)
		if str(text) == es.ServerVar('rcon_password'):
			addAdmin(userid, userid)
			block = es.import_addon('sam/base')
			block.displayMenu(userid)
			block = es.import_addon('sam/base/manager')
			block.modulePopup(userid)
			es.set('sam_first_admin', 0)
			block.editChoice(userid, es.getplayersteamid(userid), None)
		else: func.tell(userid, '#grey' + adminsText('invalidRCON', {'text':text}, func.getLang()), func.commonText('tag_server', None, func.getLang()))
		es.addons.unregisterSayFilter(chatFilter)
		return (0, 0, 0)
	else: return (userid, text, teamonly)

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_activate(ev):
	if checkDB: updateAdmin(ev['es_steamid'])

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def firstAdmin(userid):
	target = playerlib.getPlayer(userid)
	func.popupDelete('firstAdmin')
	popup = popuplib.create('firstAdmin')
	popup.addline('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.addline('\n \n :: ' + popupText('no_db', None, func.getLang()))
	popup.addline('-' * 45)
	popup.addline(' - %s\n' % (popupText('firstAdmin_line1', None, func.getLang())))
	popup.addline(' %s\n \n' % (popupText('firstAdmin_line2', None, func.getLang())))
	popup.addline(popupText('firstAdmin_line3', None, func.getLang()))
	popup.addline('->1. ' + func.commonText('yes', None, func.getLang()))
	popup.addline('->2. ' + func.commonText('no', None, func.getLang()))
	popup.addline(' ')
	popup.addline('-' * 45)
	popup.addline('0. ' + func.commonText('cancel', None, func.getLang()))
	popup.menuselect = firstPageSelect
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def firstPageSelect(userid, choice, popup):
	if choice == 1:
		es.set('sayfilter_%s' % (userid), 1)
		es.addons.registerSayFilter(chatFilter)
		func.tell(userid, '#grey' + adminsText('getRCON', None, func.getLang()), '#cyan' + hudtag)

# ============================================================================================================================================================= #