# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
actionsText = langlib.Strings(es.getAddonPath('sam') + '/langs/addons/adminschat/actions.ini')
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Admins Chat'
addon.basename = 'adminschat'
addon.desc     = actionsText('desc', None, func.getLang())
addon.version  = '1.0.p'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	''' Addon State '''
	es.set('sam_' + addon.basename, 1)

	es.addons.registerSayFilter(chatFilter)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' Addon State '''
	es.set('sam_' + addon.basename, 0)
	
	es.addons.unregisterSayFilter(chatFilter)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def chatFilter(userid, text, teamonly):
	text = text.strip('"')
	if text.startswith('@ '):
		msg = text.replace('@ ', '').replace('@', '')
		if msg != '':
			if admins.isAdmin(es.getplayersteamid(userid)):
				if admins.checkAccess(es.getplayersteamid(userid), 'Admin Chat'):
					if not teamonly:
						for ply in es.getUseridList(): func.tell2(ply, '#LightSlateGrey[ ADMINS GLOBAL ] : #spec' + msg)
						return (0, 0, 0)
					elif teamonly:
						for ply in playerlib.getPlayerList('#human'):
							if admins.isAdmin(ply.steamid): func.tell2(ply, '#DarkGreen[ ADMINS CHAT ] #lightgreen%s #DarkGreen: #green%s' % (es.getplayername(userid),msg))
						return (0, 0, 0)
			else:
				for ply in playerlib.getPlayerList('#human'):
					if admins.isAdmin(ply.steamid): func.tell2(userid, '#LawnGreen%s to Admins : #lightgreen%s' % (es.getplayername(userid),msg))
				func.tell2(userid, '#LawnGreenYou to Admins : #lightgreen%s' % msg)
				return (0, 0, 0)
		else: return (0, 0, 0)
	else: return (userid, text, teamonly)

# ============================================================================================================================================================= #