# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import playerlib
import popuplib
import time
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

# Temp Dict
temp = {}

# Keygroups
db     = 'sam_banlist'
db_dir = 'cstrike/cfg/sam/databases/es_%s_db.txt' % db

# Ban Levels
level1 = {
		 '5 Minutes':300,
		 '30 Minutes':1800,
		 '1 Hour':3600,
		 '3 Hours':10800,
		 '1 Day':86400
		 }
level2 = {
		 '3 Days':259200,
		 '1 Week':604800,
		 '1 Month':2592000,
		 '1 Year':31536000,
		 'perm':'perm'
		 }

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
langDir     = es.getAddonPath('sam') + '/langs/'
popupText   = langlib.Strings(langDir + 'pcontrol/popups.ini')
actionsText = langlib.Strings(langDir + 'pcontrol/actions.ini')
adminsText  = langlib.Strings(langDir + 'admins/admins.ini')
commonText  = langlib.Strings(langDir + 'common.ini')
hudtag = 'ADMINS ::'
bantag = '#greenBAN'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	''' Load Keygroups '''
	if os.path.isfile(db_dir) == True: es.keygroupload(db, func.default.dbfiles)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' Unload Keygroups '''
	if es.exists('keygroup', db) == 1: es.keygroupdelete(db)

	''' Popups '''
	func.popupDelete('ban')
	func.popupDelete('getReason')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(admin, target):
	if admins.checkImmunity(admin.steamid, target.steamid):
		temp[target.steamid] = {}
		temp[target.steamid]['name']      = target.name
		temp[target.steamid]['adminname'] = admin.name

		# TEMP LIST
		templist = []
		admininfo = admins.getAdmin(admin.steamid)
		if admininfo['Ban Level 1'] == 'yes':
			for item in level1: templist.append(item)
		if admininfo['Ban Level 2'] == 'yes':
			for item in level2: templist.append(item)
		templist.sort()
		templist.reverse()

		func.popupDelete('ban')
		popup = popuplib.easymenu('ban', None, banChoice)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: ' + popupText('ban_timeDesc', None, func.getLang()))
		for item in templist: popup.addoption({'steamid':target.steamid, 'choice':item}, popupText(item, None, func.getLang()))
		popup.submenu(10, 'pcontrol')
		popup.send(admin)
	else:
		block = es.import_addon('sam/base/pcontrol')
		block.modulePopup(admin)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def banChoice(userid, choice, popup):
	steamid = choice['steamid']
	length  = choice['choice']
	temp[steamid]['length'] = length 
	if not length == 'perm':
		if length in level1: temp[steamid]['banid'] = int(time.time()) + level1[length]
		elif length in level2: temp[steamid]['banid'] = int(time.time()) + level2[length]
	else: temp[steamid]['banid'] = 'perm'

	func.popupDelete('getReason')
	popup = popuplib.easymenu('getReason', None, banTarget)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: ' + popupText('ban_reasonDesc', None, func.getLang()))
	file = open('cstrike/cfg/sam/reasons.txt', 'r')
	for line in file.readlines():
		if line.startswith('-'): popup.addoption({'steamid':steamid, 'choice':line.replace('-','').strip()}, line.replace('-','').strip())
	file.close()
	popup.submenu(10, 'pcontrol')
	popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def banTarget(userid, choice, popup):
	target                 = choice['steamid']
	temp[target]['reason'] = choice['choice']
	if es.exists('keygroup', db) == 0: es.keygroupcreate(db)
	if es.exists('key', db, target) == 0: es.keycreate(db, target)
	for item in temp[target]: es.keysetvalue(db, target, item.lower(), temp[target][item])
	es.keygroupsave(db, func.default.dbfiles)
	del temp[target]

	if es.exists('userid', es.getuserid(target)):
		target = playerlib.getPlayer(es.getuserid(target))
		target.kick(reason=actionsText('tellbanned', getBanned(target.steamid), func.getLang()))
		for ply in es.getUseridList(): func.tell(ply, actionsText('banAnnounce', getBanned(target.steamid), func.getLang()), bantag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def isBanned(target):
	if es.exists('key', db, target):
		if es.keygetvalue(db, target, 'banid') == 'perm': return True
		elif int(es.keygetvalue(db, target, 'banid')) > int(time.time()): return True
		else:
			es.keydelete(db, target)
			es.keygroupsave(db, func.default.dbfiles)
			return False
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getBanned(target):
	return {'name':es.keygetvalue(db, target, 'name'),'admin':es.keygetvalue(db, target, 'adminname'),
		    'banid':es.keygetvalue(db, target, 'banid'),'reason':es.keygetvalue(db, target, 'reason'),
		    'steamid':target,'length':es.keygetvalue(db, target, 'length')}

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_activate(ev):
	if isBanned(ev['es_steamid']):
		target = playerlib.getPlayer(ev['userid'])
		target.kick(reason=actionsText('tellbanned', getBanned(target.steamid), func.getLang()))

# ============================================================================================================================================================= #