# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import playerlib
import popuplib
import time
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
langDir     = es.getAddonPath('sam') + '/langs/'
popupText   = langlib.Strings(langDir + 'pcontrol/popups.ini')
actionsText = langlib.Strings(langDir + 'pcontrol/actions.ini')
adminsText  = langlib.Strings(langDir + 'admins/admins.ini')
commonText  = langlib.Strings(langDir + 'common.ini')
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES

# Keygroups
db     = 'sam_mutelist'
db_dir = 'cstrike/cfg/sam/databases/es_%s_db.txt' % db

# Mute Lengths
lengths = {
		  '5 Minutes':300,
		  '30 Minutes':1800,
		  '1 Hour':3600,
		  '3 Hours':10800,
		  '1 Day':86400,
		  'perm':'perm'
		  }

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	''' Load Keygroups '''
	if os.path.isfile(db_dir) == True: es.keygroupload(db, func.default.dbfiles)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' Unload Keygroups '''
	if es.exists('keygroup', db) == 1: es.keygroupdelete(db)

	''' Popups '''
	func.popupDelete('mute')
	func.popupDelete('plist')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid):
	if os.path.isfile('cstrike/addons/sourcemod/plugins/basecomm.smx') == True:
		func.popupDelete('plist')
		popup = popuplib.easymenu('plist', None, plistChoice)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: ' + popupText('muteDesc', None, func.getLang()))
		for ply in playerlib.getPlayerList('#human'):
			if isMuted(ply.steamid) == True: popup.addoption(ply, '%s [Muted]' % (ply.name))
			else: popup.addoption(ply, ply.name)
		popup.submenu(10, 'pcontrol')
		popup.send(userid)
	else:
		func.hudhint(userid, actionsText('smNotFound', None, func.getLang()), 'ERROR')
		block = es.import_addon('sam/base/pcontrol')
		block.modulePopup(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def plistChoice(userid, choice, popup):
	if admins.checkImmunity(es.getplayersteamid(userid), choice):
		if isMuted(choice.steamid) == False:
			# TEMP LIST
			temp = []
			for item in lengths: temp.append(item)
			temp.sort()
			temp.reverse()

			func.popupDelete('mute')
			popup = popuplib.easymenu('mute', None, muteChoice)
			popup.c_beginsep = func.pline
			popup.c_pagesep  = func.pline
			popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
			popup.setdescription('\n \n :: ' + popupText('mute_timeDesc', None, func.getLang()))
			for item in temp: popup.addoption({'target':choice, 'time':lengths[item]}, popupText(item, None, func.getLang()))
			popup.submenu(10, 'pcontrol')
			popup.timeout('view', 10)
			popup.send(userid)
		else:
			es.keydelete(db, choice.steamid)
			es.keygroupsave(db, func.default.dbfiles)
			muteTarget('unmute', choice.name)
			func.tell(userid, actionsText('unmuted', {'target':choice.name}, func.getLang()), '#greenMUTE')
			block = es.import_addon('sam/base/pcontrol')
			block.pcontrol_Choice(userid, 'Mute', None)
	else:
		block = es.import_addon('sam/base/pcontrol')
		block.modulePopup(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def muteChoice(userid, choice, popup):
	target = choice['target']
	if es.exists('keygroup', db) == 0: es.keygroupcreate(db)
	if es.exists('key', db, target.steamid) == 0: es.keycreate(db, target.steamid)

	if choice['time'] == 'perm': status = 'perm'
	else: status = int(time.time()) + choice['time']

	es.keysetvalue(db, target.steamid, 'name', target.name)
	es.keysetvalue(db, target.steamid, 'stamp', status)
	es.keygroupsave(db, func.default.dbfiles)
	muteTarget('mute', target.name)

	func.tell(userid, actionsText('muted', {'target':target.name}, func.getLang()), '#greenMUTE')
	block = es.import_addon('sam/base/pcontrol')
	block.pcontrol_Choice(userid, 'Mute', None)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def muteTarget(cmd, target):
	var = int(es.ServerVar('sm_show_activity'))
	es.server.insertcmd('sm_show_activity 0')
	es.server.insertcmd('sm_%s %s' % (cmd, target))
	es.server.insertcmd('sm_show_activity %i' % var)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def isMuted(target):
	if es.exists('key', db, target):
		if es.keygetvalue(db, target, 'stamp') == 'perm': return True
		elif int(es.keygetvalue(db, target, 'stamp')) > int(time.time()): return True
		else:
			es.keydelete(db, target)
			es.keygroupsave(db, func.default.dbfiles)
			return False
	else: return False

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_activate(ev):
	if isMuted(ev['es_steamid']) == True: muteTarget('mute', es.getplayername(ev['userid']))

# ============================================================================================================================================================= #